<?php

@set_time_limit(0);

function CheckAbilityOfInstallation() {
global $db;
global $MODULE_FOLDER, $TMP_FOLDER, $HTTP_ROOT_PATH, $SUB_FOLDER, $DOCUMENT_ROOT;
	
	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;

	# check if all files are writeable
	$files = file($TMP_FOLDER."files.txt");

	# add check for module files
	$installed_modules = $db->get_results("SELECT `Keyword` FROM `Module`", ARRAY_A);
	if( !empty($installed_modules) ) {
		foreach ($installed_modules as $module) {
			if (file_exists($MODULE_FOLDER.$module['Keyword'])) {
				$module_files = nc_installer_filelist($TMP_FOLDER."modules/".$module['Keyword']);
				foreach ((array)$module_files AS $module_file) {
					$files[] = $SUB_FOLDER.$HTTP_ROOT_PATH."modules/".$module['Keyword']."/".$module_file;
				}
			}
		}
	}

	foreach ($files AS $file) {
		$file = $DOCUMENT_ROOT.rtrim($file);
		if (file_exists($file)) {
		# file is not writable
			if ( !is_writable($file) && !@chmod($file, 0777) ) {
###       ,      
### TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH
if( !defined("TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH") ) {
	if( defined("MAIN_LANG") && MAIN_LANG=="ru" ) {
		define("TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH", "<b>         $HTTP_ROOT_PATH.</b><br><small>(%FILE   )</small>");
	}
	else {
		define("TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH", "<b>Set writing permissiions for all files in $HTTP_ROOT_PATH directory.</b><br><small>(%FILE not available for writing)</small>");
	}
}
###
				$result['ErrorMessage'] = str_replace("%FILE", $file, TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
		else {
		# check dir
			#if(!$dirname) continue;
			$dirname = dirname($file);
			# find the nearest existing parent directory
			while ( !file_exists($dirname) ) {
				$dirname = preg_replace("!/[^/]+$!", "", $dirname);
				if ( $dirname==$DOCUMENT_ROOT.rtrim($HTTP_ROOT_PATH, "/") ) break;
			}

			# directory is not writable
			if ( !is_writable($dirname) && !@chmod($dirname, 0777) ) {
###       ,      
### TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH
if( !defined("TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH") ) {
	if( defined("MAIN_LANG") && MAIN_LANG=="ru" ) {
		define("TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH", "<b>      $HTTP_ROOT_PATH   .</b><br><small>(%DIR   )</small>");
	}
	else {
		define("TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH", "<b>Set writing permissiions for directory $HTTP_ROOT_PATH and all subdirectories.</b><br><small>(%DIR not available for writing)</small>");
	}
}
###
				$result['ErrorMessage'] = str_replace("%DIR", $dirname, TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
	}

return $result;
}


#     ,      CheckAbilityOfInstallation()
function InstallPatch() {
global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $db;
	
	$TMP_FOLDER = str_replace("#", "/", $TMP_FOLDER);

	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;

	# SystemID
	$SystemID = $db->get_var("SELECT `SystemID` FROM `Settings`");
	
	#   
	$installed_modules = $db->get_col("SELECT `Keyword`
		FROM `Module`
		WHERE `Keyword` IN ('auth', 'captcha', 'calendar', 'banner', 'blog', 'forum', 'linkmanager', 'netshop', 'poll', 'search', 'stats', 'subscriber', 'tagscloud')");
		
	foreach ($installed_modules AS $keyword) {
		# Execute SQL, if any
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".sql") ) {
			ExecSQL($TMP_FOLDER."modules/".$keyword.".sql");
		}

		# Create DIR if not exist
		if ( !file_exists($MODULE_FOLDER.$keyword) ) {
			@mkdir($MODULE_FOLDER.$keyword, 0755);
		}

		# Copy all files to modules folder
		nc_installer_copy_all($TMP_FOLDER."modules/".$keyword, $MODULE_FOLDER.$keyword);

		# include script if necessary
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".inc.php") ) {
			include ($TMP_FOLDER."modules/".$keyword.".inc.php");
		}

		# Remove old files
		if( file_exists($TMP_FOLDER."modules/".$keyword.".remove") ) {
			$files_to_remove = file($TMP_FOLDER."modules/".$keyword.".remove");
			foreach ($files_to_remove AS $file) {
				$file = trim($file, "\r\n/");
				if( @is_dir($ROOT_FOLDER.$file) ) {
					@rmdir($ROOT_FOLDER.$file);
				}
				else {
					@unlink($ROOT_FOLDER.$file);
				}
			}
		}
	}

###        /netcat/admin/patch/index.php,   !
InstallPatchAfterAction();
###

return $result;
}


function InstallPatchAfterAction() {
global $Description, $db, $PatchResult, $PatchResultText;
global $ADMIN_FOLDER, $SUB_FOLDER, $ADMIN_PATH;

###    3.0.2
#    vars.inc.php
$varsinc_writed = nc_installer_varsinc();
	

if($varsinc_writed) {
	$new_vars_inc_text = ( defined("MAIN_LANG") && MAIN_LANG=="ru" ? " vars.inc.php ." : "New vars.inc.php file stored." );
	nc_print_status($new_vars_inc_text, "info");
}
else {
	$new_vars_inc_text_err = ( defined("MAIN_LANG") && MAIN_LANG=="ru" ? "   vars.inc.php   !<br>              !" : "Error writing file vars.inc.php to root directory!<br>You shoud take it from archive with updating and writing down the necessary parameters to a root folder!" );
	nc_print_status($new_vars_inc_text_err, "error");
}
###

#    
$dump_files_moved = nc_installer_movedumps();
###
	
	###    ,    /netcat/admin/patch/function.inc.php
	if( !function_exists("nc_patch_changelog") ) {
		function nc_patch_changelog($file_name = "") {
		global $TMP_FOLDER;

			$result = false;
			$changelog_arr = array();
			if (!$file_name) {
				$int_pref = (defined("MAIN_LANG") && MAIN_LANG=="ru" ? "" : "_int");
				$file_name = "changelog".$int_pref.".txt";
			}
			
			if ( !file_exists($TMP_FOLDER.$file_name) ) return false;

			$result = file_get_contents($TMP_FOLDER.$file_name);
			$result = htmlspecialchars($result);
			
		return $result;
		}
	}
	###
	
	$changelog = nc_patch_changelog();
	if($changelog) {
		if ( !function_exists("AddSystemMessage") ) {
			include ($ADMIN_FOLDER."report/system.inc.php");
		}
		
###     3.0.2
$changelog = $db->escape($changelog);
if($Description) $Description = $db->escape($Description);

if( !defined("TOOLS_PATCH_INFO_SYSTEM_MESSAGE") ) {
	if( defined("MAIN_LANG") && MAIN_LANG=="ru" ) {
		define("TOOLS_PATCH_INFO_SYSTEM_MESSAGE", "   , <a href='%LINK'> </a>.");
	}
	else {
		define("TOOLS_PATCH_INFO_SYSTEM_MESSAGE", "New system message added, <a href='%LINK'>read message</a>.");
	}
}
###
		# AddSystemMessage(message, title),     *(O_o)*
		$sysmess = AddSystemMessage( ($PatchResultText ? $PatchResultText."\r\n" : "").$changelog, $Description ? $Description : TOOLS_PATCH_INSTALLED);
###     $sysmess    
$sysmess = $db->insert_id;
###
		#     
		if($sysmess) {
			nc_print_status( str_replace("%LINK", ($ADMIN_PATH ? $SUB_FOLDER.$ADMIN_PATH : "/netcat/admin/")."report/system.php?SystemMessageID=".$sysmess, TOOLS_PATCH_INFO_SYSTEM_MESSAGE), "info" );
		}
	}

return true;
}


function nc_installer_copy_all($from, $to) {

	$from = str_replace("#", "/", $from);
	$to = str_replace("#", "/", $to);

	$dh = @opendir($from);
	if(!$dh) return false;

	while( ( $file = readdir($dh) )!==false ) {
		if($file=="." || $file=="..") continue;
		if( @is_dir($from."/".$file) ) {
			@mkdir($to."/".$file, 0755);
			nc_installer_copy_all($from."/".$file, $to."/".$file);
		}
		else {
			copy($from."/".$file, $to."/".$file);
		}
	}

	closedir($dh);

return true;
}


function nc_installer_filelist($dir) {

	$dir = str_replace("#", "/", $dir);
	if (!$level) $start_dir = $dir;

	$ret = array();
	# non-existent dir may be passed
	$dh = @opendir($dir); 

	if (!$dh) return false;

	while ( ($file = readdir($dh))!==false ) {
		if ($file=="." || $file=="..") continue;
		if ( is_dir($dir."/".$file) ) {
			$ret = array_merge( $ret, nc_installer_filelist($dir."/".$file) );
		}
		else {
			$ret[] = preg_replace("!^$start_dir/!", "", $dir."/".$file);
		}
	}

	closedir($dh);
	
return $ret;
}


function nc_installer_varsinc() {
global $ADMIN_AUTHTIME, $ADMIN_LANGUAGE, $ADMIN_AUTHTYPE;
global $DIRCHMOD, $FILECHMOD, $PHP_TYPE, $REDIRECT_STATUS, $CHARSET, $SOURCE_CHARSET;
global $DOCUMENT_ROOT, $HTTP_ROOT_PATH, $HTTP_FILES_PATH, $use_gzip_compression;
global $AUTHORIZE_BY, $AUTHORIZATION_TYPE;
global $MYSQL_HOST, $MYSQL_USER, $MYSQL_PASSWORD, $MYSQL_DB_NAME, $MYSQL_CHARSET, $SHOW_MYSQL_ERRORS;
	
	$cfg_file = "<?php\r\n\r\n";
	$cfg_file.= "\$DOCUMENT_ROOT = getenv(\"DOCUMENT_ROOT\");\r\n";
	$cfg_file.= "\$HTTP_HOST = getenv(\"HTTP_HOST\");\r\n\r\n";
	$cfg_file.= "#     NetCat\r\n";
	$cfg_file.= "\$SUB_FOLDER = str_replace( str_replace(\"\\\\\", \"/\", \$DOCUMENT_ROOT), \"\", join(\"/\", array_slice( preg_split(\"/[\/\\\\\]+/\", __FILE__), 0, -1 ) ) );\r\n\r\n";
	$cfg_file.= "#   \r\n\r\n";
	$cfg_file.= "error_reporting(E_ALL^E_NOTICE);\r\n";
	$cfg_file.= "@ini_set(\"register_globals\",\"1\");\r\n";
	$cfg_file.= "@ini_set(\"magic_quotes_gpc\",\"1\");\r\n";
	$cfg_file.= "@ini_set(\"session.auto_start\",\"0\");\r\n\r\n";
	$cfg_file.= "@ini_set(\"session.use_trans_sid\",\"0\");\r\n";
	$cfg_file.= "@ini_set(\"session.use_cookies\",\"1\");\r\n";
	$cfg_file.= "@ini_set(\"session.use_only_cookies\",\"1\");\r\n";
	$cfg_file.= "@ini_set(\"url_rewriter.tags\", ''); // to disable trans_sid on PHP < 5.0\r\n";
	$cfg_file.= "if (\$HTTP_HOST!=\"localhost\") @ini_set(\"session.cookie_domain\", \$HTTP_HOST);\r\n\r\n";
	$cfg_file.= "@ini_set(\"session.gc_probability\",\"40\");\r\n";
	$cfg_file.= "@ini_set(\"session.gc_maxlifetime\",\"1800\");\r\n";
	$cfg_file.= "@ini_set(\"session.name\",\"sid\");\r\n\r\n";
	$cfg_file.= "#     \r\n\r\n";
	$cfg_file.= "\$MYSQL_HOST = '".$MYSQL_HOST."';\r\n";
	$cfg_file.= "\$MYSQL_USER = '".$MYSQL_USER."';\r\n";
	$cfg_file.= "\$MYSQL_PASSWORD = '".$MYSQL_PASSWORD."';\r\n";
	$cfg_file.= "\$MYSQL_DB_NAME = '".$MYSQL_DB_NAME."';\r\n";
	$cfg_file.= "\$MYSQL_CHARSET = '".($MYSQL_CHARSET ? $MYSQL_CHARSET : "cp1251")."';\r\n\r\n";
	$cfg_file.= "#  \r\n\r\n";
	$cfg_file.= "\$AUTHORIZE_BY = '".$AUTHORIZE_BY."';\r\n";
	$cfg_file.= "\$AUTHORIZATION_TYPE = '".($AUTHORIZATION_TYPE ? $AUTHORIZATION_TYPE : "cookie")."'; # 'http', 'session' or 'cookie'\r\n\r\n";
	$cfg_file.= "#  \r\n\r\n";
	$cfg_file.= "\$PHP_TYPE = '".($PHP_TYPE ? $PHP_TYPE : "module")."'; # 'module' or 'cgi'\r\n";
	$cfg_file.= "\$REDIRECT_STATUS = '".($REDIRECT_STATUS ? $REDIRECT_STATUS : "on")."'; # 'on' or 'off'\r\n\r\n";
	$cfg_file.= "\$ADMIN_LANGUAGE = '".($ADMIN_LANGUAGE ? $ADMIN_LANGUAGE : "Russian")."'; #    NetCat \"-\"\r\n";
	$cfg_file.= "\$FILECHMOD = ".($FILECHMOD ? sprintf("%04o", $FILECHMOD) : "0755")."; #       \r\n";
	$cfg_file.= "\$DIRCHMOD = ".($DIRCHMOD ? sprintf("%04o", $DIRCHMOD) : "0755")."; #       \r\n";
	$cfg_file.= "\$SHOW_MYSQL_ERRORS = '".($SHOW_MYSQL_ERRORS ? $SHOW_MYSQL_ERRORS : "off")."'; #   MySQL   \r\n";
	$cfg_file.= "\$ADMIN_AUTHTIME = ".($ADMIN_AUTHTIME ? $ADMIN_AUTHTIME : 86400)."; #      ( \$AUTHORIZATION_TYPE = session, cookie)\r\n";
	$cfg_file.= "\$ADMIN_AUTHTYPE = '".($ADMIN_AUTHTYPE ? $ADMIN_AUTHTYPE : "manual")."'; #   : 'session', 'always' or 'manual'\r\n";
	$cfg_file.= ($CHARSET ? "\$CHARSET = '".$CHARSET."'" : "#\$CHARSET = 'windows-1251'").";\r\n";
	$cfg_file.= ($SOURCE_CHARSET ? "\$SOURCE_CHARSET = '".$SOURCE_CHARSET."'" : "#\$SOURCE_CHARSET = 'koi8-r'").";\r\n\r\n";
	$cfg_file.= "\$use_gzip_compression = ".($use_gzip_compression ? "true" : "false")."; #      true\r\n\r\n";
	$cfg_file.= "#  \r\n\r\n";
	$cfg_file.= "\$DOMAIN_NAME = \$HTTP_HOST; # \$HTTP_HOST is server environment variable\r\n\r\n";
	$cfg_file.= "#\$DOCUMENT_ROOT = '".($DOCUMENT_ROOT ? $DOCUMENT_ROOT : "/usr/local/etc/httpd/htdocs/www")."';\r\n\r\n";
	$cfg_file.= "\$HTTP_IMAGES_PATH = \"/images/\";\r\n";
	$cfg_file.= "\$HTTP_ROOT_PATH = \"".($HTTP_ROOT_PATH ? $HTTP_ROOT_PATH : "/netcat/")."\";\r\n";
	$cfg_file.= "\$HTTP_FILES_PATH = \"".($HTTP_FILES_PATH ? $HTTP_FILES_PATH : "/netcat_files/")."\";\r\n";
	$cfg_file.= "\$HTTP_DUMP_PATH = \"/netcat_dump/\";\r\n\r\n";
	$cfg_file.= "#     ,  \r\n";
	$cfg_file.= "\$ADMIN_PATH = \$SUB_FOLDER.\$HTTP_ROOT_PATH.\"admin/\";\r\n";
	$cfg_file.= "#     ,    .css \r\n";
	$cfg_file.= "\$ADMIN_TEMPLATE = \$ADMIN_PATH.\"skins/default/\";\r\n";
	$cfg_file.= "#     ,    file_exists()\r\n";
	$cfg_file.= "\$ADMIN_TEMPLATE_FOLDER = \$DOCUMENT_ROOT.\$ADMIN_TEMPLATE;\r\n\r\n";
	$cfg_file.= "\$ROOT_FOLDER = \$DOCUMENT_ROOT.\$SUB_FOLDER.\$HTTP_ROOT_PATH;\r\n";
	$cfg_file.= "\$FILES_FOLDER = \$DOCUMENT_ROOT.\$SUB_FOLDER.\$HTTP_FILES_PATH;\r\n";
	$cfg_file.= "\$DUMP_FOLDER = \$DOCUMENT_ROOT.\$SUB_FOLDER.\$HTTP_DUMP_PATH;\r\n\r\n";
	$cfg_file.= "\$INCLUDE_FOLDER = \$DOCUMENT_ROOT.\$SUB_FOLDER.\$HTTP_ROOT_PATH.\"require/\";\r\n";
	$cfg_file.= "\$TMP_FOLDER = \$DOCUMENT_ROOT.\$SUB_FOLDER.\$HTTP_ROOT_PATH.\"tmp/\";\r\n";
	$cfg_file.= "\$MODULE_FOLDER = \$DOCUMENT_ROOT.\$SUB_FOLDER.\$HTTP_ROOT_PATH.\"modules/\";\r\n";
	$cfg_file.= "\$ADMIN_FOLDER = \$DOCUMENT_ROOT.\$SUB_FOLDER.\$HTTP_ROOT_PATH.\"admin/\";\r\n";
	$cfg_file.= "\$EDIT_DOMAIN = \$DOMAIN_NAME;\r\n";
	$cfg_file.= "\$DOC_DOMAIN = 'docs.netcat.ru/24';\r\n\r\n";
	$cfg_file.= "// add require/lib folder (PEAR libraries) to the include_path\r\n";
	$cfg_file.= "ini_set(\"include_path\", \"{\$INCLUDE_FOLDER}lib/\").(substr_count(strtolower(php_uname()),'windows') ? ';' : ':').ini_get(\"include_path\"); \r\n";
	$cfg_file.= "#  ,     \r\n\r\n";
	$cfg_file.= "//\$DEVELOPER_NAME='\"AIST\" JSC';\r\n";
	$cfg_file.= "//\$DEVELOPER_URL='http://www.aist.ru/';\r\n";
	$cfg_file.= "?>";

	$vars_inc_file = @fopen( dirname(__FILE__)."/../../vars.inc.php", "w" );
	$result = @fwrite($vars_inc_file, $cfg_file);

	@fclose($vars_inc_file);
	
	$vars_inc_old_renamed = @rename( dirname(__FILE__)."/../vars.inc.php", dirname(__FILE__)."/../vars.inc.old.php" );
	
	if ($vars_inc_old_renamed) {

		$rd_cfg_file = "<?php\r\n\r\n";
		$rd_cfg_file.= "# ".( defined("MAIN_LANG") && MAIN_LANG=="ru" ? "  vars.inc.php,      !" : "use vars.inc.php file, in main CMS directory!" )."\r\n";
		$rd_cfg_file.= "@include_once ( dirname(__FILE__).\"/../vars.inc.php\" );\r\n\r\n";
		$rd_cfg_file.= "?>";
		
		$vars_inc_old = @fopen( dirname(__FILE__)."/../vars.inc.php", "w" );
		$result2 = @fwrite($vars_inc_old, $rd_cfg_file);

		@fclose($vars_inc_old);
	}

return $result;
}


function nc_installer_movedumps() {

	$ret = array();
	# non-existent dir may be passed
	$old_dump_dir = @opendir( dirname(__FILE__)."/../dump/" ); 
	
	if ( !file_exists( dirname(__FILE__)."/../../netcat_dump/" ) ) @mkdir( dirname(__FILE__)."/../../netcat_dump/", 0777);
	
	if (!$old_dump_dir || !is_writable( dirname(__FILE__)."/../../netcat_dump/" ) ) return false;

	while ( ($file = @readdir($old_dump_dir))!==false ) {
		if ($file=="." || $file=="..") continue;
		#  
		$dump_file_renamed = @rename( dirname(__FILE__)."/../dump/".$file, dirname(__FILE__)."/../../netcat_dump/".$file );
	}

	@closedir($old_dump_dir);
	
}

?>