<?php

/* $Id: tree_json.php 1854 2008-03-11 08:16:31Z vadim $ */

ob_start("ob_gzhandler");

define("NC_ADMIN_ASK_PASSWORD", false);
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");

list($node_type, $node_id) = explode("-", $node);
$node_id = (int)$node_id;

// (a) path to the node
// [possible optimization point: output node info instead of ids, thus removing extra 'get path' request]
if ($_GET['action']=='get_path' && $node_type=='sub' && $node_id) {
  $parent_sub_id = $node_id;

  while ($parent_sub_id != 0) {
    $ret[] = "sub-{$parent_sub_id}";
    $row = $db->get_row("SELECT Parent_Sub_ID, Catalogue_ID FROM Subdivision WHERE Subdivision_ID = $parent_sub_id", ARRAY_A);
    if (!$row) exit("[]");
    $parent_sub_id = $row['Parent_Sub_ID'];
  }

  $ret[] = "site-$row[Catalogue_ID]";
  // remove the node itself, as it has not to be expanded
  $ret = array_reverse($ret);
  array_pop($ret);
  print nc_array_json($ret);
  exit;
}

// (b) contents of the node
$ret = array();
$ret_sites = array();
$ret_sub = array();


//      /,   /,
//     

/**
  *  sql-,    , 
  *   
  */
$security_limit = "";
$is_supervisor = ($perm->isSupervisor() || $perm->isManager());

if (!$is_supervisor) { // /  , :
  /**
    * id ,    
    */
  $site_admin = $perm->listItems('catalogue');
  /**
    * id ,    
    */
  $sub_admin = $perm->listItems('subdivision');
  /**
    * id   ,    
    */
  $cc_admin = $perm->listItems('subclass');
}

//  
if ($node_type=="root") {

  if (!$is_supervisor) {
    /**
      * id ,    (  $site_admin,
      * $sub_admin, $cc_admin)
      */
    $allowed_sites = array();

    if ($site_admin) { $allowed_sites = $site_admin; }

    if ($sub_admin) {
      $res = $db->get_results("SELECT Catalogue_ID FROM Subdivision
                               WHERE Subdivision_ID IN (".join(', ', $sub_admin).")", ARRAY_A);
      foreach ((array)$res as $row) {
        $allowed_sites[] = $row['Catalogue_ID'];
      }
    }
    if ($cc_admin) {
      $res = $db->get_results("SELECT Catalogue_ID FROM Sub_Class
                               WHERE Sub_Class_ID IN (".join(', ', $cc_admin).")", ARRAY_A);
      foreach ((array)$res as $row) {
        $allowed_sites[] = $row['Catalogue_ID'];
      }
    }
    $security_limit = " WHERE Catalogue_ID IN (".join(",", array_unique($allowed_sites)).")";
  }

  /**
    *   
    */
  $sites = $db->get_results("SELECT Catalogue_ID, Catalogue_Name, Domain, Mirrors, Checked
                               FROM Catalogue
                             $security_limit
                              ORDER BY Priority ", ARRAY_A);

  $found_current_site = false;
  foreach ((array)$sites as $site) {
    if ($site['Checked']) {
      $image = 'i_site.gif';
    } else {
      $image = 'i_site_disabled.gif';
    }

    $is_site_admin = ($is_supervisor || $perm->isCatalogueAdmin($site['Catalogue_ID']));

    $buttons = array();
    $buttons[] = array("image" => "i_preview.gif",
                       "label" => CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_VIEW,
                       "action" => "window.open('http://". (($site['Domain']) ? $site['Domain'] : $HTTP_HOST) . "');"
                      );

    if ($is_site_admin) {
      $buttons[] = array("image" => "i_folder_add.gif",
                         "label" => CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION,
                         "href" => "subdivision.add(0,$site[Catalogue_ID])");
    }

    $ret_sites[] = array("nodeId" => "site-$site[Catalogue_ID]",
                   "name" => $site[Catalogue_ID].". ".strip_tags($site["Catalogue_Name"]),
                   "href" => "#site.map($site[Catalogue_ID])",
                   "image" => $image,
                   "hasChildren" => true,
                   "acceptDropFn" => "treeSitemapAcceptDrop",
                   "onDropFn" => "treeSitemapOnDrop",
                   "dragEnabled" => $is_site_admin,
                   "buttons" => $buttons
                  );

    $domain_name = preg_quote($site['Domain']);
    if ($site['Mirrors']) { $domain_name .= "|" . preg_replace("/\r\n/", "|", preg_quote($site['Mirrors'])); }
    if ($domain_name && preg_match("/^(?:$domain_name)$/", $HTTP_HOST)) {
      $ret_sites[ sizeof($ret_sites)-1 ]["expand"] = true;
      $found_current_site = true;
    }
  }

  if (!$found_current_site) {
    $ret_sites[0]["expand"] = true;
  }
}

// 
elseif (($node_type=='sub' || $node_type=='site') && $node_id) {

  if ($node_type=='site') {
    $qry_where = "sub.Parent_Sub_ID=0 AND sub.Catalogue_ID=$node_id";
    $current_site = $node_id;
  } else {
    $qry_where = "sub.Parent_Sub_ID=$node_id";
    $current_site = $db->get_var("SELECT Catalogue_ID FROM Subdivision WHERE Subdivision_ID = $node_id");
  }

  if (!$is_supervisor) { // / .-. 
    /**
      * id ,   , 
      *  $sub_admin + $cc_admin
      */
    $sub_and_cc_admin = $sub_admin;
    if ($cc_admin) {
      $res = $db->get_results("SELECT Subdivision_ID
                                 FROM Sub_Class
                                WHERE Sub_Class_ID IN (".join(',', $cc_admin).")", ARRAY_A);
      foreach ($res as $row) {
        $sub_and_cc_admin[] = $row['Subdivision_ID'];
      }
    }

    if ($sub_and_cc_admin) {
      //     ,   
      //   
      $res = $db->get_results("SELECT parent.Subdivision_ID
                                 FROM Subdivision as parent, Subdivision as allowed
                                WHERE allowed.Subdivision_ID IN (".join(',', array_unique($sub_and_cc_admin)).")
                                  AND allowed.Hidden_URL LIKE CONCAT(parent.Hidden_URL, '%')", ARRAY_A);
      /**
        * ,    
        */
      $allowed_subs = array();
      foreach ((array)$res as $row) { // flatten array
        $allowed_subs[] = $row['Subdivision_ID'];
      }

      /**
        * id ,      ,  
        *      --   
        * (as of 3.0)
        */
      $sub_child_admin = array();
      //     
      $res = $db->get_results("SELECT child.Subdivision_ID, allowed.Subdivision_ID as Allowed_Subdivision_ID
                                 FROM Subdivision as child, Subdivision as allowed
                                WHERE allowed.Subdivision_ID IN (".join(',', array_unique($sub_admin)).")
                                  AND child.Hidden_URL LIKE CONCAT(allowed.Hidden_URL, '_%')", ARRAY_A);
      foreach ((array)$res as $row) {
        $allowed_subs[] = $row['Subdivision_ID'];
        $sub_child_admin[] = $row['Subdivision_ID'];
      }

      if ($allowed_subs && !in_array($current_site, $site_admin)) {
        $qry_where .= " AND sub.Subdivision_ID IN (".join(',', $allowed_subs).") ";
      }
    }

    $sub_administrator = $perm->listItems('subdivision', 'admin');

  } // of "not supervisor"

  $subdivisions = $db->get_results("SELECT sub.Subdivision_ID,
                                           sub.Subdivision_Name,
                                           sub.Catalogue_ID,
                                           sub.ExternalURL,
                                           sub.Hidden_URL,
                                           sub.Parent_Sub_ID,
                                           sub.Checked,
                                           sub.Catalogue_ID,
                                           catalogue.Domain
                                      FROM Subdivision AS sub
                                 	  JOIN Catalogue AS catalogue ON catalogue.Catalogue_ID = sub.Catalogue_ID
                                     WHERE $qry_where
                                     ORDER BY sub.Priority", ARRAY_A);

  $is_site_admin = $is_supervisor;
  if (!$is_supervisor && isset($subdivisions[0]['Catalogue_ID'])) {
    if (in_array($subdivisions[0]['Catalogue_ID'], $site_admin)) {$is_site_admin = true; }
  }

  foreach ((array)$subdivisions as $sub) {

    $is_subdivision_admin = $is_site_admin;

    if (!$is_site_admin) {
      if (in_array($sub['Subdivision_ID'], $sub_administrator)) {
        $is_subdivision_admin = true;
      }
      elseif (in_array($sub['Subdivision_ID'], $sub_child_admin)) { //  
        $is_subdivision_admin = true;
      }
    }

    $buttons = array();
    $buttons[] = array("image" => "i_preview.gif",
                       "label" => CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_VIEW,
                       "action" => "window.open('http://". (($sub['Domain']) ? $sub['Domain'] : $HTTP_HOST) . $SUB_FOLDER . $sub['Hidden_URL'] . "');",
                       "link_to" => "http://". (($sub['Domain']) ? $sub['Domain'] : $HTTP_HOST) . $SUB_FOLDER . ($sub['ExternalURL'] ? $sub['ExternalURL'] : $sub['Hidden_URL'])
                      );

    if ($is_subdivision_admin) {
      $buttons[] = array("image" => "i_folder_add.gif",
                         "label" => CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION,
                         "href" => "subdivision.add(".$sub['Subdivision_ID'].")");

      $buttons[] = array("image" => "i_folder_delete.gif",
                         "label" => CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_KILL,
                         "href" => "subdivision.delete(".$sub['Subdivision_ID'].")");
    }
    
    if (!$is_subdivision_admin) {
      $tree_image = "i_folder_blocked".($sub["Checked"] ? "" : "_disabled").".gif";
    } else {
      $tree_image = "i_folder".($sub["Checked"] ? "" : "_disabled").".gif";
    }
    
    $ret_sub[$sub['Subdivision_ID']] = array("nodeId" => "sub-$sub[Subdivision_ID]",
                                             "parentNodeId" => ($sub['Parent_Sub_ID'] ? "sub-$sub[Parent_Sub_ID]" : "site-$sub[Catalogue_ID]"),
                                             "name" => $sub[Subdivision_ID].". ".strip_tags($sub["Subdivision_Name"]),
                                             "href" => $is_subdivision_admin ? "#subclass.add($sub[Subdivision_ID])" : "#subdivision.view($sub[Subdivision_ID])",
                                             "image" => $tree_image,
                                             "hasChildren" => false,
                                             "dragEnabled" => $is_subdivision_admin,
                                             "buttons" => $buttons,
                                             "acceptDropFn" => "treeSitemapAcceptDrop",
                                             "onDropFn" => "treeSitemapOnDrop",
                                             "className" => ($sub["Checked"] ? "" : "disabled"),
                                             "subclasses" => array());
  } // of foreach subdivision

  /*     .  :
   *  1.     
   *  2.        
   */
  $all_subs = join(",", array_keys($ret_sub));
  if ($all_subs) {
    $subclass_data = $db->get_results("SELECT Sub_Class_ID, Class_ID, Subdivision_ID
                                         FROM Sub_Class
                                        WHERE Subdivision_ID IN ($all_subs)
                                        ORDER BY Priority",
                                      ARRAY_A);

    foreach ((array)$subclass_data as $row) {

      if (!$is_supervisor && !$is_site_admin &&
          !in_array($row['Subdivision_ID'], $sub_admin) &&
          !in_array($row['Subdivision_ID'], $sub_child_admin) &&
          !in_array($row['Sub_Class_ID'], $cc_admin))
             { continue; } //     

      if (!$ret_sub[$row['Subdivision_ID']]["subclasses"]) {
        $ret_sub[$row['Subdivision_ID']]["href"] = "#object.list($row[Sub_Class_ID])";
      }

      $ret_sub[$row['Subdivision_ID']]["subclasses"][] =
                             array("subclassId" => $row["Sub_Class_ID"],
                                   "classId" => $row["Class_ID"]);
      //$ret_sub[$row['Subdivision_ID']]["image"] = "i_folder".($sub["Checked"] ? "" : "_disabled").".gif";
    }
  }

  // check hasChildren
  if ($ret_sub) {
    $only_allowed = "";

    if (!$is_supervisor) {
      if ($allowed_subs) { $only_allowed = " AND Subdivision_ID IN (".join(',', $allowed_subs).")"; }
    }

    $children = $db->get_results("SELECT DISTINCT Parent_Sub_ID
                                    FROM Subdivision
                                   WHERE Parent_Sub_ID IN (".join(",", array_keys($ret_sub)).")
                                         $only_allowed", ARRAY_A);
    foreach ((array)$children as $sub) {
       $ret_sub[$sub['Parent_Sub_ID']]['hasChildren'] = true;
    }
  } // of "hasChildren?"

}

/**
  *    
  */
$ret = array_merge(array_values($ret_sites), array_values($ret_sub));
print nc_array_json($ret);

?>